// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/accelerometer_apb_wrapper.hpp"



accelerometer_apb_wrapper::accelerometer_apb_wrapper() :
    analog_clock_old(false),
    pwdata_old(0UL),
    pwrite_old(false),
    penable_old(false),
    psel_old(false),
    paddr_old(0UL),
    presetn_old(false),
    pclk_old(false),
    hif_a2t_data(
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr),
    prdata_var(0UL),
    ddt_7(0.0),
    ddt_6(0.0),
    ddt_5(0.0),
    ddt_4(0.0),
    ddt_3(0.0),
    ddt_2(0.0),
    ddt_1(0.0),
    ddt_0(0.0),
    ddt(0.0),
    cap7_d(uint8_t(0U)),
    cap7_d_var(uint8_t(0U)),
    cap5_d(uint8_t(0U)),
    cap5_d_var(uint8_t(0U)),
    cap2_d(uint8_t(0U)),
    cap2_d_var(uint8_t(0U)),
    cap1_d(uint8_t(0U)),
    cap1_d_var(uint8_t(0U)),
    acc_cap7_sample(0.0),
    acc_cap5_sample(0.0),
    acc_cap2_sample(0.0),
    acc_cap1_sample(0.0),
    acc_cap7_over(false),
    acc_cap5_over(false),
    acc_cap2_over(false),
    acc_cap1_over(false),
    acc_i(0L),
    b_avx(
    0.0,
    0.0),
    b_avy(
    0.0,
    0.0),
    b_avz(
    0.0,
    0.0),
    b_acc_reduced_0(
    0.0,
    0.0),
    b_acc_reduced_1(
    0.0,
    0.0),
    b_acc_reduced_0_dot(
    0.0,
    0.0),
    b_acc_reduced_1_dot(
    0.0,
    0.0),
    b_acc_avx_dot(
    0.0,
    0.0),
    b_acc_avy_dot(
    0.0,
    0.0),
    b_acc_avz_dot(
    0.0,
    0.0),
    b_acc_Cap1(
    0.0,
    0.0),
    b_acc_Cap2(
    0.0,
    0.0),
    b_acc_Cap5(
    0.0,
    0.0),
    b_acc_Cap7(
    0.0,
    0.0),
    cap7_d_new(uint8_t(0U)),
    cap5_d_new(uint8_t(0U)),
    cap2_d_new(uint8_t(0U)),
    cap1_d_new(uint8_t(0U)),
    process_in_queue(false),
    flag_analog_clock(false),
    flag_process_1_acc_process_executed(false),
    flag_pos_pclk(false)
{
}


accelerometer_apb_wrapper::~accelerometer_apb_wrapper()
{}


void accelerometer_apb_wrapper::process_2_acc_process_0()
{
    b_avx.pot = sin( _system_abstime() * 7.22566 ) * 3.3;
    b_avy.pot = sin( _system_abstime() * 20.4204 ) * 1.65;
    b_avz.pot = sin( _system_abstime() * 61.638 ) * 2.56;
    b_acc_reduced_0.pot = 0.0;
    b_acc_reduced_0.flw = b_acc_avx_dot.flw * -0.0819711 + b_acc_avy_dot.pot * 4.73383e-05
         + b_acc_avz_dot.pot * -1.17331e-09 + b_acc_reduced_0.pot * 4.33864e-07
         + b_acc_reduced_0_dot.pot * 0.00548179 + b_acc_reduced_1.pot * -1.33629e-11
         + b_acc_reduced_1_dot.pot * -1.68838e-07 + b_avx.pot * 1.63942e-06 + ddt
         * -1.63942e-06 + ddt_2 * -0.00548179 + ddt_3 * 1.68838e-07;
    b_acc_reduced_1.pot = 0.0;
    b_acc_reduced_1.flw = b_acc_avx_dot.flw * -46.9192 + b_acc_avy_dot.pot * -8.27034e-08
         + b_acc_avz_dot.pot * -6.71585e-07 + b_acc_reduced_0.pot * -1.33629e-11
         + b_acc_reduced_0_dot.pot * -1.68838e-07 + b_acc_reduced_1.pot * 4.26215e-07
         + b_acc_reduced_1_dot.pot * 0.00538515 + b_avx.pot * 0.000938383 + ddt
         * -0.000938383 + ddt_5 * 1.68838e-07 + ddt_6 * -0.00538515;
    b_acc_reduced_0_dot.pot = 0.0;
    b_acc_reduced_0_dot.flw = b_acc_reduced_0.pot * 2e-05 + b_acc_reduced_0_dot.pot
         * -1e-06 + ddt_4 * -2e-05;
    b_acc_reduced_1_dot.pot = 0.0;
    b_acc_reduced_1_dot.flw = b_acc_reduced_1.pot * 2e-05 + b_acc_reduced_1_dot.pot
         * -1e-06 + ddt_7 * -2e-05;
    b_acc_avx_dot.pot = b_acc_avx_dot.flw * -1e+06 + b_avx.pot * 20.0 + ddt * -20.0;
    b_acc_avx_dot.flw = 0.0;
    b_acc_avy_dot.pot = 0.0;
    b_acc_avy_dot.flw = b_acc_avy_dot.pot * -1e-06 + b_avy.pot * 2e-05 + ddt_0 *
         -2e-05;
    b_acc_avz_dot.pot = 0.0;
    b_acc_avz_dot.flw = b_acc_avz_dot.pot * -1e-06 + b_avz.pot * 2e-05 + ddt_1 *
         -2e-05;
    b_acc_Cap1.pot = b_acc_reduced_0.pot * 2.14643e-15 + b_acc_reduced_1.pot * 6.02191e-14
         - 3.20699e-13;
    b_acc_Cap2.pot = b_acc_reduced_0.pot * -6.07571e-14 + b_acc_reduced_1.pot *
         2.12929e-15 - 3.20699e-13;
    b_acc_Cap5.pot = b_acc_reduced_0.pot * -2.14642e-15 + b_acc_reduced_1.pot *
         -6.02199e-14 + 3.20699e-13;
    b_acc_Cap7.pot = b_acc_reduced_0.pot * 6.07579e-14 + b_acc_reduced_1.pot * -2.1293e-15
         + 3.20699e-13;

    // DDT(accelerometer_apb_wrapper_V_avx)
    ddt = b_avx.pot;

    // DDT(accelerometer_apb_wrapper_V_avy)
    ddt_0 = b_avy.pot;

    // DDT(accelerometer_apb_wrapper_V_avz)
    ddt_1 = b_avz.pot;

    // DDT(accelerometer_apb_wrapper_V_acc_reduced_0_dot)
    ddt_2 = b_acc_reduced_0_dot.pot;

    // DDT(accelerometer_apb_wrapper_V_acc_reduced_1_dot)
    ddt_3 = b_acc_reduced_1_dot.pot;

    // DDT(accelerometer_apb_wrapper_V_acc_reduced_0)
    ddt_4 = b_acc_reduced_0.pot;

    // DDT(accelerometer_apb_wrapper_V_acc_reduced_0_dot)
    ddt_5 = b_acc_reduced_0_dot.pot;

    // DDT(accelerometer_apb_wrapper_V_acc_reduced_1_dot)
    ddt_6 = b_acc_reduced_1_dot.pot;

    // DDT(accelerometer_apb_wrapper_V_acc_reduced_1)
    ddt_7 = b_acc_reduced_1.pot;
}


void accelerometer_apb_wrapper::process_1_acc_process()
{
    prdata_var = *hif_a2t_data.prdata;
    if (*hif_a2t_data.penable == true)
    {
        prdata_var = prdata_var & 16777215UL | static_cast< uint32_t >( cap7_d 
            ) << 24L;
        prdata_var = prdata_var & 4278255615UL | static_cast< uint32_t >( cap5_d
             ) << 16L;
        prdata_var = prdata_var & 4294902015UL | static_cast< uint32_t >( cap2_d
             ) << 8L;
        prdata_var = prdata_var & 4294967040UL | cap1_d;
        *hif_a2t_data.pready = true;
    }
    else
    {
        prdata_var = 0UL;
        *hif_a2t_data.pready = false;
    }
    *hif_a2t_data.prdata = prdata_var;
    cap1_d_var = cap1_d;
    cap2_d_var = cap2_d;
    cap5_d_var = cap5_d;
    cap7_d_var = cap7_d;
    acc_cap7_sample = (std::abs( b_acc_Cap7.pot ) - 3.201e-13) / 8e-16;
    if (acc_cap7_sample > 255.0)
    {
        acc_cap7_sample = 255.0;
    }
    if (acc_cap7_sample < 0.0)
    {
        acc_cap7_sample = 0.0;
    }
    acc_cap5_sample = (std::abs( b_acc_Cap5.pot ) - 3.201e-13) / 8e-16;
    if (acc_cap5_sample > 255.0)
    {
        acc_cap5_sample = 255.0;
    }
    if (acc_cap5_sample < 0.0)
    {
        acc_cap5_sample = 0.0;
    }
    acc_cap2_sample = (std::abs( b_acc_Cap2.pot ) - 3.201e-13) / 8e-16;
    if (acc_cap2_sample > 255.0)
    {
        acc_cap2_sample = 255.0;
    }
    if (acc_cap2_sample < 0.0)
    {
        acc_cap2_sample = 0.0;
    }
    acc_cap1_sample = (std::abs( b_acc_Cap1.pot ) - 3.201e-13) / 8e-16;
    if (acc_cap1_sample > 255.0)
    {
        acc_cap1_sample = 255.0;
    }
    if (acc_cap1_sample < 0.0)
    {
        acc_cap1_sample = 0.0;
    }
    for (acc_i = 7L; acc_i >= 0L; acc_i = acc_i - 1L)
    {
        acc_cap7_over = acc_cap7_sample >= 1.65;
        acc_cap5_over = acc_cap7_sample >= 1.65;
        acc_cap2_over = acc_cap7_sample >= 1.65;
        acc_cap1_over = acc_cap7_sample >= 1.65;
        if (acc_cap7_over)
        {
            acc_cap7_sample = acc_cap7_sample - 1.65;
        };
        if (acc_cap5_over)
        {
            acc_cap5_sample = acc_cap5_sample - 1.65;
        };
        if (acc_cap2_over)
        {
            acc_cap2_sample = acc_cap2_sample - 1.65;
        };
        if (acc_cap1_over)
        {
            acc_cap1_sample = acc_cap1_sample - 1.65;
        };
        acc_cap7_sample = acc_cap7_sample * 2.0;
        acc_cap5_sample = acc_cap5_sample * 2.0;
        acc_cap2_sample = acc_cap2_sample * 2.0;
        acc_cap1_sample = acc_cap1_sample * 2.0;
        cap7_d_var = acc_cap7_over ? static_cast< uint8_t >( cap7_d_var | static_cast<
             uint8_t >( uint8_t(1U) << static_cast< uint8_t >( acc_i ) ) ) : static_cast<
             uint8_t >( cap7_d_var & static_cast< uint8_t >( ~static_cast< uint8_t
             >( uint8_t(1U) << static_cast< uint8_t >( acc_i ) ) ) );
        cap5_d_var = acc_cap5_over ? static_cast< uint8_t >( cap5_d_var | static_cast<
             uint8_t >( uint8_t(1U) << static_cast< uint8_t >( acc_i ) ) ) : static_cast<
             uint8_t >( cap5_d_var & static_cast< uint8_t >( ~static_cast< uint8_t
             >( uint8_t(1U) << static_cast< uint8_t >( acc_i ) ) ) );
        cap2_d_var = acc_cap2_over ? static_cast< uint8_t >( cap2_d_var | static_cast<
             uint8_t >( uint8_t(1U) << static_cast< uint8_t >( acc_i ) ) ) : static_cast<
             uint8_t >( cap2_d_var & static_cast< uint8_t >( ~static_cast< uint8_t
             >( uint8_t(1U) << static_cast< uint8_t >( acc_i ) ) ) );
        cap1_d_var = acc_cap1_over ? static_cast< uint8_t >( cap1_d_var | static_cast<
             uint8_t >( uint8_t(1U) << static_cast< uint8_t >( acc_i ) ) ) : static_cast<
             uint8_t >( cap1_d_var & static_cast< uint8_t >( ~static_cast< uint8_t
             >( uint8_t(1U) << static_cast< uint8_t >( acc_i ) ) ) );
    }

    cap7_d_new = cap7_d_var;
    cap5_d_new = cap5_d_var;
    cap2_d_new = cap2_d_var;
    cap1_d_new = cap1_d_var;
}


void accelerometer_apb_wrapper::update_input_queue( bool synch_phase )
{
    process_in_queue = false;
    if (*hif_a2t_data.pclk != pclk_old)
    {
        pclk_old = *hif_a2t_data.pclk;
        if (*hif_a2t_data.pclk == true)
        {
            flag_pos_pclk = true;
        }
        else
        {
            flag_pos_pclk = false;
        }
        process_in_queue = true;
    }
    else
    {
        flag_pos_pclk = false;
    }
    presetn_old = *hif_a2t_data.presetn;
    paddr_old = *hif_a2t_data.paddr;
    psel_old = *hif_a2t_data.psel;
    penable_old = *hif_a2t_data.penable;
    pwrite_old = *hif_a2t_data.pwrite;
    pwdata_old = *hif_a2t_data.pwdata;
    if (*hif_a2t_data.analog_clock != analog_clock_old)
    {
        analog_clock_old = *hif_a2t_data.analog_clock;
        flag_analog_clock = true;
        process_in_queue = true;
    }
    else
    {
        flag_analog_clock = false;
    }
}


void accelerometer_apb_wrapper::update_event_queue()
{
    process_in_queue = false;
    update_input_queue( false );
    cap1_d = cap1_d_new;
    cap2_d = cap2_d_new;
    cap5_d = cap5_d_new;
    cap7_d = cap7_d_new;
}


void accelerometer_apb_wrapper::flag_elaboration()
{
    if (flag_analog_clock)
    {
        process_2_acc_process_0();
    }
    flag_process_1_acc_process_executed = false;
    if (flag_pos_pclk)
    {
        process_1_acc_process();
        flag_process_1_acc_process_executed = true;
    }
}


void accelerometer_apb_wrapper::start_of_simulation()
{
    process_2_acc_process_0();
    process_1_acc_process();
    flag_process_1_acc_process_executed = true;
}


void accelerometer_apb_wrapper::initialize()
{
    start_of_simulation();
}




